# README
====

To run this:

Install docker compose on the server / computer.  
Ref: https://docs.docker.com/compose/install/linux/  

Note: in case you haven't made docker command directly usable by the logged in user, then put "sudo " prefix on all docker commands below.


Create the persistent data folders
```
mkdir -p ./persistent-data/db ./persistent-data/logs
docker compose up -d --build
```
Note: it is important to make the persisten-data folders by ourself

To stop the program,
```
docker compose down
```

To rebuild and restart just one service:
```
docker compose up -d --build server-launch
```

To see logs:
```
docker compose logs -f
```

Clean sweep restart:
```
rm -rf persistent-data/
mkdir -p ./persistent-data/db ./persistent-data/logs
docker compose up -d --build
```
Warning: above "rm" command will DELETE the existing database. Use with caution.

## How to know it's running

http://localhost:5000/docs : should show a swagger ui with the api calls

http://localhost:5000 : should show the html/index.html rendered as a webpage.

If testing on server, then pls replace "localhost" with your server host / ip, and allow port 5000 in case there is a firewall active. (like: `sudo ufw allow 5000`)

## Credentials

See DB and Email credentials in deployment.env . They are sample values; you can substitute with proper password etc.

Even with the current DB credentials, the docker compose will setup the DB with that.


If you want to test the emailing api, then please first populate correct SMTP credentials in the deployment.env file.

Note: But if you change the password of DB anytime in future, you will need to re-create the DB.


## API Calls

/api/listrows : Will show data in DB

/api/addrow : can be used to add a row to DB.
After that, hit /api/listrows api again and you should be able to see the newly entered value show up.

/api/emailapi : To test SMTP email sending. Use only AFTER you've entered your SMTP details in the deployment.env file and rebuilt and re-deployed the docker compose.


